import styled from 'styled-components';
import PropTypes from 'prop-types';

const Overlay = styled.div`
  width: 100%;
  position: fixed;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  z-index: ${({ zIndex }) => zIndex};
  opacity: ${({ isOpen }) => (isOpen ? 1 : 0)};
  visibility: ${({ isOpen }) => (isOpen ? 'visible' : 'hidden')};
  transition: opacity .3s, visibility .3s;
  background-color: rgba(0, 0, 0, 0.3);
`;

Overlay.propTypes = {
  isOpen: PropTypes.bool.isRequired,
  zIndex: PropTypes.number.isRequired,
};

export default Overlay;
