import styled from 'styled-components';
import PropTypes from 'prop-types';

const SidebarWrapper = styled.div`
  position: fixed;
  width: 300px;
  top: 0;
  bottom: 0;
  outline: none;
  z-index: ${({ zIndex }) => zIndex};
  ${({ side }) => side}: ${({ isOpen }) => (isOpen ? 0 : '-300px')};
  transition: left .3s, right .3s;
  overflow-y: auto;
`;

SidebarWrapper.propTypes = {
  side: PropTypes.oneOf(['left', 'right']).isRequired,
  isOpen: PropTypes.bool.isRequired,
  zIndex: PropTypes.number.isRequired,
};

export default SidebarWrapper;
