import {
  MOUNT_SIDEBAR,
  OPEN_SIDEBAR,
  HIDE_SIDEBAR,
  UNMOUNT_SIDEBAR,
} from './constants';


const mountSidebar = sidebar => ({
  type: MOUNT_SIDEBAR,
  sidebar,
});

const openSidebar = component => ({
  type: OPEN_SIDEBAR,
  component,
});


export const handleOpeningSidebar = sidebar => (dispatch) => {
  const defaultSidebar = {
    side: 'left',
    sidebarProps: {},
  };
  const mergedSidebar = { ...defaultSidebar, ...sidebar };
  dispatch(mountSidebar(mergedSidebar));
  setTimeout(() => { dispatch(openSidebar(mergedSidebar.component)); }, 100);
};

const hideSidebar = component => ({
  type: HIDE_SIDEBAR,
  component,
});

const unmountSidebar = component => ({
  type: UNMOUNT_SIDEBAR,
  component,
});

export const handleHidingSidebar = component => (dispatch) => {
  dispatch(hideSidebar(component));
  setTimeout(() => { dispatch(unmountSidebar(component)); }, 400);
};

