import {
  MOUNT_SIDEBAR,
  OPEN_SIDEBAR,
  HIDE_SIDEBAR,
  UNMOUNT_SIDEBAR,
} from './constants';

export const initialState = {
  sidebars: [],
};

export default function sidebars(state = initialState, action) {
  switch (action.type) {
    case MOUNT_SIDEBAR:
      return {
        sidebars: state.sidebars.concat({
          ...action.sidebar,
          isVisible: false,
        }),
      };
    case OPEN_SIDEBAR:
      return {
        sidebars: state.sidebars.map(sidebar => (
          sidebar.component === action.component
            ? { ...sidebar, isVisible: true }
            : sidebar
        )),
      };
    case HIDE_SIDEBAR:
      return {
        sidebars: state.sidebars.map(sidebar => (
          sidebar.component === action.component
            ? { ...sidebar, isVisible: false }
            : sidebar
        )),
      };
    case UNMOUNT_SIDEBAR:
      return {
        sidebars: state.sidebars.filter(sidebar => (
          sidebar.component !== action.component
        )),
      };
    default:
      return state;
  }
}
